#Embedded file name: eve/client/script/ui/login/charSelection\characterSelectionColors.py
"""
    This file contains the UI colors for the character slots on the character selection screen.
    There are 2 basecolors (basecolor1 is primarly used), and they can be tweaked.
    Ideally, when theming an expansion, only those colors are changed, and alpha, saturation + brightness are tuned to
    get the desired color (if needed).
"""
from carbonui.util.color import GetColor
BASECOLOR1 = (118 / 255.0, 163 / 255.0, 255 / 255.0)
BASECOLOR2 = (255 / 255.0, 149 / 255.0, 0 / 255.0)
DARKBASE = (0.0, 0.0, 0.0)
BASECOLOR1_FILL = GetColor(BASECOLOR1, alpha=0.3, brightness=0.7)
BASECOLOR1_TEXT_ACTIVE = GetColor(BASECOLOR1, alpha=1.0, saturation=0.1)
BASECOLOR1_TEXT_INACTIVE = GetColor(BASECOLOR1, alpha=1.0, saturation=0.2, brightness=0.9)
BASECOLOR1_FRAME_ACTIVE = GetColor(BASECOLOR1, alpha=0.4)
BASECOLOR1_FRAME_INACTIVE = GetColor(BASECOLOR1, alpha=0.25)
FRAME_GLOW_ACTIVE = (1.0, 1.0, 1.0, 1.0)
FRAME_GLOW_INACTIVE = (1.0, 1.0, 1.0, 0.3)
SLOT_BACKGROUND = GetColor(DARKBASE, alpha=0.8)
OUTER_FRAME = GetColor(BASECOLOR1, alpha=0.6, saturation=0.7)
INNER_FRAME_ACTIVE = GetColor(BASECOLOR1, alpha=0.6)
INNER_FRAME_INACTIVE = GetColor(BASECOLOR1, alpha=0.6)
PORTRAIT_INACTIVE = GetColor(BASECOLOR1, alpha=1.0, brightness=0.8, saturation=0.3)
PORTRAIT_INACTIVE_SATURATION = 0.0
PORTRAIT_INACTIVE_EFFECT_OPACITY = 0.7
PLUS_ACTIVE = GetColor(BASECOLOR1, alpha=1.0, saturation=0.1, brightness=0.8)
PLUS_INACTIVE = GetColor(BASECOLOR1, alpha=1.0, saturation=0.1, brightness=0.7)
LINES_ACTIVE = BASECOLOR1_FRAME_ACTIVE
LINES_INACTIVE = BASECOLOR1_FRAME_INACTIVE
LINES_TEXT_ACTIVE = BASECOLOR1_TEXT_ACTIVE
LINES_TEXT_INACTIVE = BASECOLOR1_TEXT_INACTIVE
LINES_ICON_ACTIVE = GetColor(BASECOLOR1, alpha=0.8, saturation=1.0)
LINES_ICON_INACTIVE = GetColor(BASECOLOR1, alpha=0.6, saturation=0.8)
NAME_CONT_FILL_ACTIVE = GetColor(BASECOLOR1, alpha=0.4)
NAME_CONT_FILL_INACTIVE = GetColor(DARKBASE, alpha=0.4)
NAME_LABEL_ACTIVE = BASECOLOR1_TEXT_ACTIVE
NAME_LABEL_INACTIVE = GetColor(BASECOLOR1, alpha=1.0, saturation=0.1, brightness=0.7)
SKILLQUEUE_BACKGROUND_ACTIVE = BASECOLOR1_FILL
SKILLQUEUE_BACKGROUND_INACTIVE = BASECOLOR1_FILL
SKILLQUEUE_FILL_ACTIVE = GetColor(BASECOLOR1, alpha=0.3)
SKILLQUEUE_FILL_INACTIVE = GetColor(BASECOLOR1, alpha=0.2)
SKILLQUEUE_BRIGHT_EDGE = GetColor(BASECOLOR1, alpha=0.7)
SKILLQUEUE_FRAME_TRAINING_ACTIVE = BASECOLOR1_FRAME_ACTIVE
SKILLQUEUE_FRAME_TRAINING_INACTIVE = BASECOLOR1_FRAME_INACTIVE
SKILLQUEUE_FRAME_NOT_TRAINING_ACTIVE = BASECOLOR1_FRAME_ACTIVE
SKILLQUEUE_FRAME_NOT_TRAINING_INACTIVE = BASECOLOR1_FRAME_INACTIVE
SKILLQUEUE_TEXT_TRAINING_ACTIVE = BASECOLOR1_TEXT_ACTIVE
SKILLQUEUE_TEXT_TRAINING_INACTIVE = BASECOLOR1_TEXT_INACTIVE
SKILLQUEUE_TEXT_NOT_TRAINING_ACTIVE = BASECOLOR1_TEXT_ACTIVE
SKILLQUEUE_TEXT_NOT_TRAINING_INACTIVE = BASECOLOR1_TEXT_INACTIVE
SKILLQUEUE_TEXT2_TRAINING_ACTIVE = BASECOLOR1_TEXT_ACTIVE
SKILLQUEUE_TEXT2_TRAINING_INACTIVE = BASECOLOR1_TEXT_INACTIVE
OTHER_FRAME = GetColor(BASECOLOR2, alpha=0.3)
OTHER_FRAME_INACTIVE = GetColor(BASECOLOR2, alpha=0.1)
OTHER_FILL = GetColor(BASECOLOR1, alpha=0.25)
LOCATION_FILL_ACTIVE = GetColor(BASECOLOR1, alpha=0.4, brightness=1.0)
LOCATION_FILL_INACTIVE = BASECOLOR1_FILL
LOCATION_FRAME_ACTIVE = BASECOLOR1_FRAME_ACTIVE
LOCATION_FRAME_INACTIVE = BASECOLOR1_FRAME_INACTIVE
LOCATION_TEXT_ACTIVE = BASECOLOR1_TEXT_ACTIVE
LOCATION_TEXT_INACTIVE = BASECOLOR1_TEXT_INACTIVE
GRID_ACTIVE = GetColor(BASECOLOR1, alpha=0.1, saturation=0.3)
GRID_INACTIVE = GetColor(BASECOLOR1, alpha=0.1, saturation=0.3)
GRID_SCALE = GetColor(BASECOLOR1, alpha=0.3, saturation=0.3)
SHIP_ICON_ACTIVE = GetColor(BASECOLOR1, alpha=1.0, brightness=0.7, saturation=0.7)
SHIP_ICON_INACTIVE = GetColor(BASECOLOR1, alpha=1.0, brightness=0.4, saturation=0.7)
SHIP_NAME_ACTIVE = GetColor(BASECOLOR1, alpha=1.0, brightness=0.7, saturation=0.3)
SHIP_NAME_INACTIVE = GetColor(BASECOLOR1, alpha=1.0, brightness=0.4, saturation=0.3)
VIGNETTE_ACTIVE = GetColor(BASECOLOR1, alpha=0.3, brightness=0.6, saturation=0.3)
VIGNETTE_INACTIVE = GetColor(BASECOLOR1, alpha=0.2, brightness=0.6, saturation=0.3)
VIGNETTE_DISABLED = GetColor(BASECOLOR1, alpha=0.15, brightness=0.6, saturation=0.3)
SUBSCRIPTION_BORDER_FILL = GetColor(DARKBASE, alpha=0.25)
ADDCHARACTER_TEXT_ACTIVE = GetColor(BASECOLOR1, alpha=1.0, brightness=0.75, saturation=1.0)
REDEEM_BORDER = BASECOLOR1_FRAME_ACTIVE
REDEEM_BORDER_FILL = BASECOLOR1_FILL
REDEEM_BORDER_BACKGROUND = GetColor(DARKBASE, alpha=1.0)
REDEEM_EXPAND = BASECOLOR1_TEXT_INACTIVE
REDEEM_PANEL_FILL = GetColor(DARKBASE, alpha=1.0)
REDEEM_GRID = GetColor(BASECOLOR1, alpha=0.05, saturation=0.3)
REDEEM_PANEL_AVAILABLE_TEXT = BASECOLOR1_TEXT_INACTIVE
REDEEM_PANEL_DRAG_TEXT = GetColor(BASECOLOR1, alpha=0.6, saturation=0.15, brightness=0.9)
TOKEN_FRAME_ACTIVE = BASECOLOR1_FRAME_ACTIVE
TOKEN_FRAME_INACTIVE = BASECOLOR1_FRAME_INACTIVE
TOKEN_FILL = GetColor(DARKBASE, alpha=1.0)
TOKEN_HIGHLIGHT = GetColor(BASECOLOR1, alpha=0.2)
TOKEN_NAME_FILL_ACTIVE = GetColor(BASECOLOR1, alpha=0.4, brightness=1.0)
TOKEN_NAME_FILL_INACTIVE = BASECOLOR1_FILL
TOKEN_TEXT_ACTIVE = BASECOLOR1_TEXT_ACTIVE
TOKEN_TEXT_INACTIVE = BASECOLOR1_TEXT_INACTIVE
TOKEN_DESCR = BASECOLOR1_TEXT_INACTIVE
BIOMASS_PORTRAIT = (0.1, 0.1, 0.1, 1)
BIOMASS_RED = (1.0, 0.0, 0.0, 0.75)
BIOMASS_WHITE = (1.0, 1.0, 1.0, 0.75)
